package edu.laura.temaValaszt.choose;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import edu.laura.temaValaszt.jdbc.JDBCDataSource;

public class ChooseBL {
	
    //visszateriti az osszes tema listajat
	//mindenfele informacioval (project tabla adatai+ azon diakok nevei,
	//akik temat valasztottak) egyutt:
	public static List getList(Integer studentID){
		Connection connection = JDBCDataSource.getConnection();
		//SQL parancs:
		Statement statement;
		List list=new ArrayList();
		Map map=new HashMap();
		try {
			statement = connection.createStatement();
			ResultSet resultSet = statement.executeQuery("SELECT * FROM project;  ");
			while(resultSet.next()){
				AssignmentBean assignmentBean =new AssignmentBean();
				assignmentBean.setThemeID(new Integer(resultSet.getInt("ObjectID")));
				assignmentBean.setThemeName(resultSet.getString("Title"));
				assignmentBean.setProposedBy(new Integer (resultSet.getInt("ProposedBy")));
				assignmentBean.setState(new Integer (resultSet.getInt("State")));
				list.add(assignmentBean);
							}
			statement = connection.createStatement();
			resultSet = statement.executeQuery("SELECT * FROM student s, studenttoproject sp " +
					"where s.ObjectID=sp.StudentID; ");
			while(resultSet.next()){
				AssignmentBean assignmentBean =new AssignmentBean();
				assignmentBean.setStudentID(new Integer (resultSet.getInt("s.ObjectID")));
				assignmentBean.setStudentFirstName(resultSet.getString("s.FirstName"));
				assignmentBean.setStudentLastName(resultSet.getString("s.LastName"));
				assignmentBean.setThemeID(new Integer (resultSet.getInt("sp.ProjectID")));
				map.put(assignmentBean.getThemeID(), assignmentBean);
			}
		    resultSet.close();
		    statement.close();
		    
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		finally{
			try {
				connection.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	    Iterator iterator=list.iterator();
	    while (iterator.hasNext()) {
			AssignmentBean assignmentBean = (AssignmentBean) iterator.next();
			AssignmentBean studentAttributes=(AssignmentBean)map.get(assignmentBean.getThemeID());
			if(studentAttributes!=null){
				assignmentBean.setStudentID(studentAttributes.getStudentID());
				assignmentBean.setStudentFirstName(studentAttributes.getStudentFirstName());
				assignmentBean.setStudentLastName(studentAttributes.getStudentLastName());
			}
		}
	    return list;
}

	
	
	//visszateriti az osszes FOGLALT tema azonositojat, nevet, diakID, vezetek- es keresztnevet, 
	// ki javasolta a temat es a tema statusat  
	/*public static List getAssignedList(Integer studentID){
		Connection connection = JDBCDataSource.getConnection();
		//SQL parancs:
		Statement statement;
		List list=new ArrayList();
		try {
			statement = connection.createStatement();
			ResultSet resultSet = statement.executeQuery("SELECT" +
					" s.ObjectID, p.ObjectID, s.FirstName, s.LastName, p.Title, p.ProposedBy, p.State " +
					"FROM studenttoproject sp, student s, project p " +
					"WHERE sp.StudentID=s.ObjectID AND sp.ProjectID=p.ObjectID;");
			while(resultSet.next()){
				AssignmentBean assignmentBean =new AssignmentBean();
				assignmentBean.setThemeID(new Integer(resultSet.getInt("p.ObjectID")));
				assignmentBean.setThemeName(resultSet.getString("p.Title"));
				assignmentBean.setStudentID(new Integer(resultSet.getInt("s.ObjectID")));
				assignmentBean.setStudentFirstName(resultSet.getString("s.FirstName"));
				assignmentBean.setStudentLastName(resultSet.getString("s.LastName"));
				assignmentBean.setProposedBy(new Integer (resultSet.getInt("p.ProposedBy")));
				assignmentBean.setState(new Integer (resultSet.getInt("p.State")));
				list.add(assignmentBean);
							}
		    
		    resultSet.close();
		    statement.close();
		    connection.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	    
	    return list;
}*/
	//visszateriti a szabad temak listajat (temaID, tema cime)
	public static List getUnassignedThemes(){
		Connection connection = JDBCDataSource.getConnection();
		//SQL parancs:
		Statement statement;
		List list=new ArrayList();
	
		try {
			statement = connection.createStatement();
			//kivalasztjuk a szabad projektek listajat:
			ResultSet resultSet = statement.executeQuery("SELECT p.ObjectID, p.Title " +
					"FROM project p left outer join studenttoproject sp on p.ObjectID=sp.ProjectID " +
					"where sp.ObjectID is null;");
			while(resultSet.next()){
				IDNameBean idNameBean =new IDNameBean();
				idNameBean.setId(new Integer(resultSet.getInt("p.ObjectID")));
				idNameBean.setName(resultSet.getString("p.Title"));
				
				list.add(idNameBean);
							}			
		    resultSet.close();
		    statement.close();
		    connection.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return list;
	}
	
	//torli a parameterkent megadott azonositoju felhasznalo valasztasat, illetve a temat is, ha azt a diak javasolta
	public static void remove(Integer studentID){
		Connection connection = JDBCDataSource.getConnection();
		//SQL parancs:
		Statement statement;
		
		try {
		  	 statement = connection.createStatement();
		  	 
		  	 ResultSet resultSet = statement.executeQuery("SELECT p.ObjectID, p.State " +
		  	 		"FROM studenttoproject sp, project p " +
		     		"where sp.StudentID="+studentID+" and p.ObjectID=sp.ProjectID;");
		  	 statement = connection.createStatement();
		  	 statement.executeUpdate("DELETE FROM studenttoproject where StudentID="+studentID+";");
		  	 resultSet.next();
		  	 //a tema State mezeje 1 - ha az a tanar altal javasolt tema
		     if(resultSet.getInt("p.State")!=1){
		    	 int projectIDtoDelete=resultSet.getInt("p.ObjectID");
		    	 statement = connection.createStatement();
		    	 statement.executeUpdate("DELETE FROM project where ObjectID="+projectIDtoDelete+";");
			 }
		  			     
		     resultSet.close();
			 statement.close();
			 connection.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	// a studenttoproject tablaba beir egy uj bejegyzest
	//a StudentID azonositoju diak kivalasztotta a ProjectID azonositoju temat
	public static void assign(Integer studentID, Integer projectID){
		Connection connection = JDBCDataSource.getConnection();
		//SQL parancs:
		Statement statement;
		
		try {
		  	 statement = connection.createStatement();
		  	 
		     statement.executeUpdate("Insert into studenttoproject (ProjectID, StudentID) " +
		     		"values ("+projectID+", "+studentID+");");
		  			     
		     statement.close();
			 connection.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	
	public static void newTheme(String newProject, String newProjectDescription,Integer studentID){
		Connection connection = JDBCDataSource.getConnection();
		//SQL parancs:
		Statement statement;
		Integer projectID;
		try {
		  	 statement = connection.createStatement();
		  	 statement.executeUpdate("Insert into project (Title, Description, ProposedBy,State) " +
		     		"values ('"+newProject+"', '"+newProjectDescription+"',"+studentID+",2);");
		  	 
		  	 statement = connection.createStatement();
		  	 ResultSet resultSet = statement.executeQuery("SELECT ObjectID " +
					"FROM project " +
					"where ProposedBy="+studentID+" and Title='"+newProject+"';");
		  	 
		  	 resultSet.next();
		  	 projectID=new Integer(resultSet.getInt("ObjectID"));
		  	 statement = connection.createStatement();
		     statement.executeUpdate("Insert into studenttoproject (ProjectID, StudentID) " +
		     		"values ("+projectID+", "+studentID+");");
		  			     
		     resultSet.close();
		     statement.close();
			 connection.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
}
